/**
  *  \file planetscentral/talk/user.h
  *  \brief Talk: User profile access
  */
#ifndef C2SERVER_PLANETSCENTRAL_TALK_USER_H
#define C2SERVER_PLANETSCENTRAL_TALK_USER_H

#include "planetscentral/dbclient/dbsubtree.h"
#include "cpluslib/string.h"

/** User profile access. Contains accessors to talk-related user profile data. */
class User {
 public:
    User(DbClient& client, string_t userId);

    string_t  getScreenName();
    string_t  getLoginName();
    string_t  getRealName();
    IntValue* getProfileRaw(string_t key);
    string_t  getPMMailType();

    bool      isAutoWatch();
    bool      isWatchIndividual();

    DbHash    profile();
    DbSubtree forumData();
    DbIntSet  postedMessages();
    DbSubtree newsrc();

    DbSubtree pmFolderData();
    DbInt     pmFolderCount();
    DbIntSet  pmFolders();

    DbIntSet  watchedForums();
    DbIntSet  watchedTopics();
    DbIntSet  notifiedForums();
    DbIntSet  notifiedTopics();

    static string_t getUserIdFromLogin(DbClient& db, string_t login);

 private:
    DbSubtree user;
};

#endif
